<template>
  <SinglePane class="card-wrapper">
    <div class="organization-page">
      <div class="heading-wrapper">
        <div class="heading">
          <i
            v-if="role === 'moderator' || role === 'administrator'"
            class="icon chevron-left heading__back-button"
            @click="onStepBack"
          />

          <span class="heading__title">
            {{ participantTitle || "—" }}
          </span>

          <div
            v-if="role === 'moderator'"
            class="heading__actions"
          >
            <div
              v-if="isReportPending"
              class="heading__loader"
            >
              <ObLoader />
            </div>

            <ObTooltip
              v-else
              content="Скачать отчёт о проверке Sum&Substance"
            >
              <i
                @click="downloadReport"
                class="icon download heading__button"
              />
            </ObTooltip>

            <ObMenuDropdown :items="menu" />
          </div>
        </div>

        <ObTabs
          :items="modifiedTabs"
          :no-border="true"
          class="heading-tabs"
          @on-change-tab="onChangeTab"
        />
      </div>

      <common-page
        v-if="selectedTab.name === 'basicData'"
        @setData="setData"
      />

      <documents
        v-else-if="selectedTab.name === 'documents'"
        :method="getDocumentsMethod()"
        type="organisations"
      />
      <!-- :with-editing="true" -->

      <invoices v-else-if="selectedTab.name === 'invoices' && isModerator" />
    </div>

    <deleteWarning
      ref="delete-warning"
      :error-message="deleteWarningErrorMessage"
      @submit="deleteOrganization"
    >
      {{ participantTitle }}
    </deleteWarning>
  </SinglePane>
</template>

<script>
import api from "@/api";
import SinglePane from "common-components/src/obComponents/obSinglePanels";
import ObMenuDropdown from "common-components/src/obComponents/obMenuDropdown";
import ObTooltip from "common-components/src/obComponents/obTooltip";
import ObLoader from "common-components/src/obComponents/obLoader";
import ObTabs from "common-components/src/obComponents/obTabs";
import deleteWarning from "../../../components/SB/delete-warning";
import commonPage from "./tabs/common";
import documents from "../../../components/SB/documents";
import invoices from "./tabs/invoicesModerator";

export default {
  components: {
    SinglePane,
    ObMenuDropdown,
    ObTooltip,
    ObLoader,
    ObTabs,
    deleteWarning,
    commonPage,
    documents,
    invoices
  },
  computed: {
    ...mapGetters({
      isModerator: "user/isModerator"
    }),
    modifiedTabs: ({ tabs }) => tabs
  },
  data() {
    return {
      participantTitle: null,
      participantUuid: null,
      role: null,
      isReportPending: false,
      menu: [
        {
          title: "Удалить участника",
          className: "-light-raspberry-red",
          icon: "trash",
          method: this.showDeleteWarning
        }
      ],
      selectedTab: null,
      tabs: [
        {
          title: "Основные данные",
          name: "basicData",
          id: 1
        },
        {
          title: "Документы",
          name: "documents",
          id: 2
        },
        {
          title: "Расчетные счета",
          name: "invoices",
          id: 3
        }
      ],
      deleteWarningErrorMessage: null
    };
  },
  beforeMount () {
    this.selectedTab = this.tabs[0]
  },
  methods: {
    setData({ participantTitle, participantUuid, role }) {
      this.participantTitle = participantTitle;
      this.participantUuid = participantUuid;
      this.role = role;
    },
    getDocumentsMethod () {
      return api.organisations.getDocuments
    },
    onStepBack() {
      this.$router.push({ path: "/organizations" });
      document.title = "Участники";
    },
    async downloadReport () {
      this.isReportPending = true

      try {
        const data = await api.organisations.downloadReport(this.participantUuid)
        const url = URL.createObjectURL(new Blob([data]))
        const link = document.createElement("a")

        link.href = url
        link.setAttribute("download", `Отчет о проверке Sum&Substance (${this.participantTitle}).pdf`)

        document.body.appendChild(link)

        link.click()
        link.remove()
      } catch (e) {
        console.error(e)

        this.$notification({
          type: "system_notification_error",
          message: "Невозможно сформировать отчет"
        });
      }

      // Added small timeout to prevent loader flicking
      setTimeout(() => this.isReportPending = false, 500)
    },
    showDeleteWarning () {
      this.deleteWarningErrorMessage = null

      this.$refs['delete-warning'].open()
    },
    async deleteOrganization () {
      try {
        await api.organisations.deleteParticipant(this.participantUuid);

        this.$notification({
          type: "system_notification_success",
          message: "Организация успешно удалена"
        });

        this.onStepBack();
      } catch (e) {
        console.error(e);

        switch (e.code) {
          case 2:
            this.deleteWarningErrorMessage = "Участник участвует в заказах"
            break

          case 3:
            this.deleteWarningErrorMessage = "Участник участвует во вторичных заказах"
            break

          case 4:
            this.deleteWarningErrorMessage = "Участник участвует в тендерах"
            break

          case 5:
            this.deleteWarningErrorMessage = "Участник участвует в аукционах"
            break

          default:
            this.deleteWarningErrorMessage = "Ошибка удаления участника"
            break
        }

        this.$notification({
          type: "system_notification_error",
          message: "Ошибка удаления участника"
        });
      }
    },
    onChangeTab (tab) {
      this.selectedTab = tab;
    }
  }
};
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/mixins";

$icon-size: 24px;

.card-wrapper {
  overflow: hidden; // To clip shadows
}

.heading-wrapper {
  position: relative;
  z-index: 1; // To override layer with <ObTable> shadow

  &::after {
    content: "";
    position: absolute;
    top: 0;
    left: 0;
    z-index: 1; // Over ObFuncPanel elements
    width: 100%;
    height: 100%;
    pointer-events: none;
    box-shadow:
      0 0 2px rgba($blue-700, 0.15),
      0 0 12px rgba($blue-700, 0.04),
      0 4px 10px rgba($blue-700, 0.06);
  }
}

.heading {
  display: flex;
  padding: 22px 10px 21px 20px;
  border-bottom: 1px solid $lavender;
  margin-bottom: 11px;

  &__back-button {
    font-size: $icon-size;
    margin-right: 20px;
    color: $color-blue-navy-blue;
    cursor: pointer;
    align-self: center;
  }

  &__title {
    // 29px to pixel-perfected as in Figma (Figma props: 30px height, 28px line-height)
    @include font-mixin(20px, 29px, bold, $Grey-900, 0.4);
  }

  &__actions {
    margin-left: auto;
    display: grid;
    grid-auto-flow: column;
    grid-column-gap: 10px;
    align-items: center;

    &::v-deep {
      color: $blue-700;

      .menu-dropdown-list__item button i {
        color: inherit;

        &::before {
          color: inherit;
        }
      }
    }
  }

  &__button {
    cursor: pointer;
    font-size: $icon-size;
  }

  &__loader {
    width: $icon-size;
    height: $icon-size;
    transform: scale(0.6); // Equal to $icon-size (60% of 40px)
    display: flex;
    align-items: center;
    justify-content: center;
  }
}

.heading-tabs {
  padding: 0 20px;
}
</style>
